/* 
 * File:   config_addresses.h
 * Author: John
 *
 * Created on February 4, 2018, 2:25 PM
 */

#define ALT_WRITE 0xC0
#define ALT_READ 0xC1
#define lidar_read 0xC5
#define lidar_write 0xC4
#define GAM_WRITE 0xD6
#define GAM_READ 0xD7

#define low 0
#define high 1
#define output 0
#define input 1
#define disabled 0
#define enabled 1
#define active_low_enable 0 /*! @define active_low_enable\ The value assigned to an active low pin to enable it (0). */
#define active_low_disable 1 /*! @define active_low_disable\ The value assigned to an active low pin to disable it (1). */

#define MOTOR_A1 LATEbits.LATE6
#define MOTOR_A2 LATEbits.LATE7
#define MOTOR_B1 LATFbits.LATF0
#define MOTOR_B2 LATBbits.LATB4

#define MOTOR_C1 LATEbits.LATE3
#define MOTOR_C2 LATEbits.LATE4
#define MOTOR_D1 LATEbits.LATE5
#define MOTOR_D2 LATBbits.LATB3

#define LIGHT_POWDER1 LATEbits.LATE0
#define LIGHT_POWDER2 LATEbits.LATE1

#define CHECK_INITIALIZATION LATBbits.LATB0
#define DRIVE_CENTER_ON 10000
#define DRIVE_PERIOD 30000

bool SLOW_MOTOR = 0;
int SWITCH_MODE = 0;
int MEASURE_TIMER_CONDITION = 1;
int COUNT_SECONDS = 0;
#define DRIVE_FORWARD 0
#define DRIVE_BACKWARD 1
#define TURN_LEFT 2
#define TURN_RIGHT 3
#define COAST 4
int in_flight_mode = 0;
int SWITCH_COMMAND = 0;
#define PREPARE_FOR_FLIGHT 1
#define ARM_ROVER 2
#define LIGHT_CHARGES1 3
#define LIGHT_CHARGES2 4
#define DEPLOY_ROVER 5
#define MOVE_ROVER 6
#define DEPLOY_SOLAR_PANELS 7

bool newDataRead = true;

#define GPS_RESET LATBbits.LATB12