/* 
 * File:   config_pins.h
 * Author: cstgeo
 *
 * Created on December 29, 2017, 11:42 AM
 */

#ifndef CONFIG_PINS_H
#define	CONFIG_PINS_H
#include "config.h"

// Pin TRIS Mapping
/* TRISB */
 #define PicKit3_PGD_IO TRISBbits.TRISB0
 #define PicKit3_PGC_IO TRISBbits.TRISB1
 #define BLE_nCS1_IO    TRISBbits.TRISB2
 #define BLE_nCS2_IO    TRISBbits.TRISB3
 #define BLE_nCS3_IO    TRISBbits.TRISB4
 // TRISBbits.TRISB5
 #define MUX_A_IO       TRISBbits.TRISB6
 #define MUX_B_IO       TRISBbits.TRISB7
 #define LORA_nRTS_IO   TRISBbits.TRISB8 /* UART 2 !CTS */
 #define GPS_nRESET_IO  TRISBbits.TRISB9
 // TRISBbits.TRISB10
 // TRISBbits.TRISB11
 // TRISBbits.TRISB12
 // TRISBbits.TRISB13
 #define LORA_nCTS_IO   TRISBbits.TRISB14 /* UART 2 !RTS */
 #define GPS_3DFIX_IO   TRISBbits.TRISB15

/* TRISC */
 // TRISCbits.TRISC12
 #define ALT_INT1_IO    TRISCbits.TRISC13
 #define ALT_INT2_IO    TRISCbits.TRISC14
 // TRISCbits.TRISC15

/* TRISD */
 #define MUX_nE_IO	TRISDbits.TRISD0
 #define RS232_nCTS_IO  TRISDbits.TRISD1 /* UART 1 !RTS */
 #define RS232_TXD_IO   TRISDbits.TRISD2 /* UART 1 RXD */
 #define RS232_RXD_IO   TRISDbits.TRISD3 /* UART 1 TXD */
 #define GAM_INT_M_IO   TRISDbits.TRISD4
 #define GAM_INT1_AG_IO TRISDbits.TRISD5
 #define GAM_INT2_AG_IO TRISDbits.TRISD6
 #define GAM_DRDY_IO    TRISDbits.TRISD7
 #define GAM_DEN_AG_IO  TRISDbits.TRISD8
 #define RS232_nRTS_IO  TRISDbits.TRISD9 /* UART 1 !CTS */
 #define GAM_SDO_AG_IO  TRISDbits.TRISD10
 #define GAM_SDO_M_IO   TRISDbits.TRISD11

/* TRISE */
 #define BLE_nRESET1_IO	TRISEbits.TRISE0
 #define BLE_nAT1_IO    TRISEbits.TRISE1
 #define BLE_nPWRC1_IO  TRISEbits.TRISE2
 #define BLE_nRESET2_IO	TRISEbits.TRISE3
 #define BLE_nAT2_IO    TRISEbits.TRISE4
 #define BLE_nPWRC2_IO  TRISEbits.TRISE5
 #define BLE_nRESET3_IO TRISEbits.TRISE6
 #define BLE_nAT3_IO    TRISEbits.TRISE7

/* TRISF */
 #define BLE_nPWRC3_IO	TRISFbits.TRISF0
 #define LORA_nRESET_IO TRISFbits.TRISF1
 #define USBID_IO       TRISFbits.TRISF3
 #define LORA_TXD_IO	TRISFbits.TRISF4 /* UART 2 RXD */
 #define LORA_RXD_IO	TRISFbits.TRISF5 /* UART 2 TXD */

/* TRISG */
 #define D_MINUS_IO	TRISGbits.TRISG2
 #define D_PLUS_IO      TRISGbits.TRISG3
 #define MUX_RXD_IO     TRISGbits.TRISG6 /* UART 6 TXD */
 #define I2C_SDA_IO	TRISGbits.TRISG7 /* SDA4 */
 #define I2C_SCL_IO	TRISGbits.TRISG8 /* SCL4 */
 #define MUX_TXD_IO	TRISGbits.TRISG9 /* UART 6 RXD */

// Pin PORT Mapping
/* PORTB */
 #define PicKit3_PGD_R  PORTBbits.RB0
 #define PicKit3_PGC_R  PORTBbits.RB1
 #define BLE_nCS1_R     PORTBbits.RB2
 #define BLE_nCS2_R     PORTBbits.RB3
 #define BLE_nCS3_R     PORTBbits.RB4
 // PORTBbits.RB5
 #define MUX_A_R        PORTBbits.RB6
 #define MUX_B_R        PORTBbits.RB7
 #define LORA_nRTS_R    PORTBbits.RB8 /* UART 2 !CTS */
 #define GPS_nRESET_R   PORTBbits.RB9
 // PORTBbits.RB10
 // PORTBbits.RB11
 // PORTBbits.RB12
 // PORTBbits.RB13
 #define LORA_nCTS_R    PORTBbits.RB14 /* UART 2 !RTS */
 #define GPS_3DFIX_R    PORTBbits.RB15

/* PORTC */
 // PORTCbits.RC12
 #define ALT_INT1_R     PORTCbits.RC13
 #define ALT_INT2_R     PORTCbits.RC14
 // PORTCbits.RC15

/* PORTD */
 #define MUX_nE_R       PORTDbits.RD0
 #define RS232_nCTS_R   PORTDbits.RD1 /* UART 1 !RTS */
 #define RS232_TXD_R    PORTDbits.RD2 /* UART 1 RXD */
 #define RS232_RXD_R    PORTDbits.RD3 /* UART 1 TXD */
 #define GAM_INT_M_R    PORTDbits.RD4
 #define GAM_INT1_AG_R  PORTDbits.RD5
 #define GAM_INT2_AG_R  PORTDbits.RD6
 #define GAM_DRDY_R     PORTDbits.RD7
 #define GAM_DEN_AG_R   PORTDbits.RD8
 #define RS232_nRTS_R   PORTDbits.RD9 /* UART 1 !CTS */
 #define GAM_SDO_AG_R   PORTDbits.RD10
 #define GAM_SDO_M_R    PORTDbits.RD11

/* PORTE */
 #define BLE_nRESET1_R	PORTEbits.RE0
 #define BLE_nAT1_R     PORTEbits.RE1
 #define BLE_nPWRC1_R   PORTEbits.RE2
 #define BLE_nRESET2_R	PORTEbits.RE3
 #define BLE_nAT2_R     PORTEbits.RE4
 #define BLE_nPWRC2_R   PORTEbits.RE5
 #define BLE_nRESET3_R  PORTEbits.RE6
 #define BLE_nAT3_R     PORTEbits.RE7

/* PORTF */
 #define BLE_nPWRC3_R	PORTFbits.RF0
 #define LORA_nRESET_R  PORTFbits.RF1
 #define USBID_R        PORTFbits.RF3
 #define LORA_TXD_R	PORTFbits.RF4 /* UART 2 RXD */
 #define LORA_RXD_R	PORTFbits.RF5 /* UART 2 TXD */

/* PORTG */
 #define D_MINUS_R	PORTGbits.RG2
 #define D_PLUS_R       PORTGbits.RG3
 #define MUX_RXD_R      PORTGbits.RG6 /* UART 6 TXD */
 #define I2C_SDA_R	PORTGbits.RG7 /* SDA4 */
 #define I2C_SCL_R	PORTGbits.RG8 /* SCL4 */
 #define MUX_TXD_R	PORTGbits.RG9 /* UART 6 RXD */

// Pin LAT Mapping
/* LATB */
 #define PicKit3_PGD    LATBbits.LATB0
 #define PicKit3_PGC    LATBbits.LATB1
 #define BLE_nCS1       LATBbits.LATB2
 #define BLE_nCS2       LATBbits.LATB3
 #define BLE_nCS3       LATBbits.LATB4
 // LATBbits.LATB5   
 #define MUX_A          LATBbits.LATB6
 #define MUX_B          LATBbits.LATB7
 #define LORA_nRTS      LATBbits.LATB8 /* UART 2 !CTS */
 #define GPS_nRESET     LATBbits.LATB9
 // LATBbits.LATB10   
 // LATBbits.LATB11   
 // LATBbits.LATB12   
 // LATBbits.LATB13   
 #define LORA_nCTS      LATBbits.LATB14 /* UART 2 !RTS */
 #define GPS_3DFIX      LATBbits.LATB15

/* LATC */
 // LATCbits.LATC12
 #define ALT_INT1       LATCbits.LATC13
 #define ALT_INT2       LATCbits.LATC14
 // LATCbits.LATC15

/* LATD */
 #define MUX_nE	       LATDbits.LATD0
 #define RS232_nCTS    LATDbits.LATD1 /* UART 1 !RTS */
 #define RS232_TXD     LATDbits.LATD2 /* UART 1 RXD */
 #define RS232_RXD     LATDbits.LATD3 /* UART 1 TXD */
 #define GAM_INT_M     LATDbits.LATD4
 #define GAM_INT1_AG   LATDbits.LATD5
 #define GAM_INT2_AG   LATDbits.LATD6
 #define GAM_DRDY      LATDbits.LATD7
 #define GAM_DEN_AG    LATDbits.LATD8
 #define RS232_nRTS    LATDbits.LATD9 /* UART 1 !CTS */
 #define GAM_SDO_AG    LATDbits.LATD10
 #define GAM_SDO_M     LATDbits.LATD11

/* LATE */
 #define BLE_nRESET1   LATEbits.LATE0
 #define BLE_nAT1      LATEbits.LATE1
 #define BLE_nPWRC1    LATEbits.LATE2
 #define BLE_nRESET2   LATEbits.LATE3
 #define BLE_nAT2      LATEbits.LATE4
 #define BLE_nPWRC2    LATEbits.LATE5
 #define BLE_nRESET3   LATEbits.LATE6
 #define BLE_nAT3      LATEbits.LATE7

/* LATF */
 #define BLE_nPWRC3    LATFbits.LATF0
 #define LORA_nRESET   LATEbits.LATE3
 #define USBID         LATFbits.LATF3
 #define LORA_TXD      LATFbits.LATF4 /* UART 2 RXD */
 #define LORA_RXD      LATFbits.LATF5 /* UART 2 TXD */

/* LATG */
 #define D_MINUS       LATGbits.LATG2
 #define D_PLUS        LATGbits.LATG3
 #define MUX_RXD       LATGbits.LATG6 /* UART 6 TXD */
 #define I2C_SDA       LATGbits.LATG7 /* SDA4 */
 #define I2C_SCL       LATGbits.LATG8 /* SCL4 */
 #define MUX_TXD       LATGbits.LATG9 /* UART 6 RXD */

// Pin CNEN Mapping
typedef union {
  struct {
    unsigned _ALT_INT2:1;  //CNEN0:1;
    unsigned _ALT_INT1:1;  //CNEN1:1;
    unsigned :1;  //CNEN2:1;
    unsigned :1;  //CNEN3:1;
    unsigned _BLE_nCS1:1;  //CNEN4:1;
    unsigned _BLE_nCS2:1;  //CNEN5:1;
    unsigned _BLE_nCS3:1;  //CNEN6:1;
    unsigned :1;  //CNEN7:1;
    unsigned :1;  //CNEN8:1;
    unsigned :1;  //CNEN9:1;
    unsigned :1; //CNEN10:1;
    unsigned :1; //CNEN11:1;
    unsigned _GPS_3DFIX:1; //CNEN12:1;
    unsigned _GAM_INT_M:1; //CNEN13:1;
    unsigned _GAM_INT1_AG:1; //CNEN14:1;
    unsigned _GAM_INT2_AG:1; //CNEN15:1;
    unsigned _GAM_DRDY:1; //CNEN16:1;
    unsigned :1; //CNEN17:1;
    unsigned :1; //CNEN18:1;
  };
  struct {
    unsigned w:32;
  };
} CNEN_t;
extern volatile CNEN_t _CNEN __asm__ ("CNEN") __attribute__((section("sfrs"), address(0xBF8861D0)));

typedef union {
  struct {
    unsigned _ALT_INT2:1;  //CNPUE0:1;
    unsigned _ALT_INT1:1;  //CNPUE1:1;
    unsigned :1;  //CNPUE2:1;
    unsigned :1;  //CNPUE3:1;
    unsigned _BLE_nCS1:1;  //CNPUE4:1;
    unsigned _BLE_nCS2:1;  //CNPUE5:1;
    unsigned _BLE_nCS3:1;  //CNPUE6:1;
    unsigned :1;  //CNPUE7:1;
    unsigned :1;  //CNPUE8:1;
    unsigned :1;  //CNPUE9:1;
    unsigned :1; //CNPUE10:1;
    unsigned :1; //CNPUE11:1;
    unsigned _GPS_3DFIX:1; //CNPUE12:1;
    unsigned _GAM_INT_M:1; //CNPUE13:1;
    unsigned _GAM_INT1_AG:1; //CNPUE14:1;
    unsigned _GAM_INT2_AG:1; //CNPUE15:1;
    unsigned _GAM_DRDY:1; //CNPUE16:1;
    unsigned :1; //CNPUE17:1;
    unsigned :1; //CNPUE18:1;
  };
  struct {
    unsigned w:32;
  };
} CNPUE_t;
extern volatile CNPUE_t _CNPUE __asm__ ("CNPUE") __attribute__((section("sfrs"), address(0xBF8861E0)));



#endif	/* CONFIG_PINS_H */

